
import { world } from '@minecraft/server';

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockTypeRegistry.registerCustomComponent('fd:on_interact', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem && selectedItem.typeId === 'fb:ball_pit') {

                const permutation = block.permutation;
                const currentLayerLevel = permutation.getState('fd:layer_level');
                if (currentLayerLevel <= 6) {
                    e.cancel = true;
                    const newLayerLevel = currentLayerLevel + 1;
                    const newPermutation = permutation.withState('fd:layer_level', newLayerLevel);
                    block.setPermutation(newPermutation);
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else {
                            equipment.setEquipment('Mainhand', undefined);
                        }
                    }
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockTypeRegistry.registerCustomComponent('fd:on_place', {
        onPlace(e) {
            const { block } = e;
            const permutation = block.permutation;
            if (permutation.getState('fd:layer_level') === 0) {
            }
        }
    });
});