//bridge-file-version: #28
import { ActionFormData, ModalFormData} from "@minecraft/server-ui"
import { world, system, ItemStack} from '@minecraft/server'


world.beforeEvents.itemUse.subscribe(eventData => {               // OPEN THE UI                                             
	const player = eventData.source
	if (eventData.itemStack.typeId == 'a:catalog') {
	  system.run(() => {
		catalog(player)
		player.runCommand('playsound item.book.page_turn @s ~~+1~')
    player.runCommand('scoreboard objectives add money dummy')      
	  })
	}
  })

  function rec(player, objective, min, max) {
    if (min == max) { return min }  
    const middle = min + Math.floor((max - min) / 2)
    const p1 = world.getPlayers({ name: player.name, scoreOptions: [{ objective: objective, minScore: min, maxScore: middle }] })
    if (p1.length === 1) { return rec(player, objective, min, middle) } 
    else { return rec(player, objective, middle + 1, max) } 
  }
  function getScore(player, objective) {
    const p1 = world.getPlayers({ name: player.name, scoreOptions: [{ objective: objective, minScore: -2147483648, maxScore: 2147483647 }] })
    if (p1.length === 0) { return 0 } 
    return rec(player, objective, -2147483648, 2147483647) 
  }
  




function catalog(player) {
    let form = new ActionFormData();
    const score = getScore(player, "money");
    form.title("§l§8[§0ADD-ONS  CATALOG§8]")
    form.body(`Discover more Furniture Add-ons!`)
    form.button('§8»§0 MODERN FURNITURE §2[Download]', 'textures/icons/MF.png')
    form.button('§8»§0 FEUDAL FURNITURE §2[Download]', 'textures/icons/FF.png')
    form.button(' §8»§0 PET FURNITURE  §2[Download]', 'textures/icons/PF.png')
    form.button('     §8»§0 TRMC APP       §2[Download]', 'textures/icons/APP.png')
    form.button('   §8»§0 GIVE US FEEDBACK   §2[Join]', 'textures/icons/DISCORD.png')
    form.button("§4« Exit")
    form.show(player).then(result => {
      if (result.selection === 0) {
        mf(player);
      }
      if (result.selection === 1) {
        ff(player);
      }
      if (result.selection === 2) {
        pf(player);
      }
      if (result.selection === 3) {
       app(player);
      }
      if (result.selection === 4) {
        discord(player);
      }
      if (result.selection === 5) {
        Menu(player)
      }
    })
  }

  
function mf(player) {
let form = new ActionFormData();
    form.title("§l§8[§0MODERN FURNITURE§8]")
    form.body(`§l» Description§r

Modern Furniture adds more than 700 simple, functional and modern furniture! 

This Add-On Adds many types of furniture: chairs, sofas, tables, lamps, stairs, carpets, Kitchen furniture, etc.

§l» Download§r

§2www.trmc-studios.com/mf

`)
   
    form.button("§4« Go Back")
    form.show(player).then(result => {
      if (result.selection === 0) {
        catalog(player);
      }
    })
  }






function ff(player) {
let form = new ActionFormData();
    const score = getScore(player, "money");
    form.title("§l§8[§0FEUDAL FURNITURE§8]")
    form.body(`§l» Description§r

Feudal Furniture adds more than 650 medieval furniture with all wood variants!

This Add-On Adds many types of furniture: tables, tends, stools, targets, shelves, books, boards, signs, logs, etc.

§l» Download§r

§2www.trmc-studios.com/ff

`)
   
    form.button("§4« Go Back")
    form.show(player).then(result => {
      if (result.selection === 0) {
        catalog(player);
      }
    })
  }

function pf(player) {
let form = new ActionFormData();
    const score = getScore(player, "money");
    form.title("§l§8[§0PET FURNITURE§8]")
    form.body(`§l» Description§r

Pet Furniture adds over 250 fully functional pet furniture!

This Add-On Adds many types of furniture: dog beds, kennels, chicken coop, cat flaps, scratching post, feeders and much more!

§l» Download§r

§2www.trmc-studios.com/pf

`)
   
    form.button("§4« Go Back")
    form.show(player).then(result => {
      if (result.selection === 0) {
        catalog(player);
      }
    })
  }




function app(player) {
let form = new ActionFormData();
    form.title("§l§8[§0TRMC APP§8]")
    form.body(`§l» Description§r

TRMC APP is the official Android application from TRMC Studios, with it you can acquire the more than 15 Add-ons and 10 maps that we offer totally free!

§l» Download§r

§2www.trmc-studios.com/app

`)
   
    form.button("§4« Go Back")
    form.show(player).then(result => {
      if (result.selection === 0) {
        catalog(player);
      }
    })
  }




function discord(player) {
let form = new ActionFormData();
    form.title("§l§8[§0DISCORD SERVER§8]")
    form.body(`§l» Description§r
    
Join our discord and give feedback, ideas and proposals for future updates!

§l» Join§r

§2www.trmc-studios.com/discord

`)
   
    form.button("§4« Go Back")
    form.show(player).then(result => {
      if (result.selection === 0) {
        catalog(player);
      }
    })
  }


  